'
' Manipulate the 16-bit HPWM peripherals on a 12F1571 or 12F1572 device
' Written by Les Johnson for the Proton BASIC compiler
' 
    Device = 12F1571
    Declare Xtal = 16
'
' Setup the bit-bashed serial out (for seeing the values on the serial terminal)
'  
    Declare Serial_Baud = 9600
    Declare RsOut_Pin = PORTA.4
    Declare RsOut_Mode = 0
    Declare RsOut_Pace = 1000
    
    Include "HPWM_12F157X.inc"          ' Load the HPWM library into the program
'
' Create some variables for the demo
'  
    Dim wDuty1 As Word = 0              ' Create a variable for the Duty of the HPWM1 signal
    Dim wDuty2 As Word = 0              ' Create a variable for the Duty of the HPWM2 signal
    Dim wDuty3 As Word = 0              ' Create a variable for the Duty of the HPWM3 signal
    
    Dim wPeriod1 As Word = 0            ' Create a variable for the Perios of the HPWM1 signal
    Dim wPeriod2 As Word = 0            ' Create a variable for the Perios of the HPWM2 signal
    Dim wPeriod3 As Word = 0            ' Create a variable for the Perios of the HPWM3 signal
    
'-------------------------------------------------------------------------------
' The main program starts here
'      
Main:
    OSCCON = %01111010                  ' Setup the device for internal clock at 16MHz
  
    HPWM1_Period(10000)                 ' Set the period of HPWM1
    HPWM2_Period(10000)                 ' Set the period of HPWM2
    HPWM3_Period(10000)                 ' Set the period of HPWM3
     
    Do                                  ' Create an infinite loop
        HPWM1_Duty(wDuty1)              ' \
        HPWM2_Duty(wDuty2)              ' | Set the duty of the HPWM peripherals
        HPWM3_Duty(wDuty3)              ' /
        
        wDuty1 = wDuty1 + 10            ' \
        wDuty2 = wDuty2 + 10            ' | Increment the duty values
        wDuty3 = wDuty3 + 10            ' /
        '
        ' Transmit the duty values so we can see them on a serial terminal
        '
        RsOutLn "Duty1 = ", Dec wDuty1, " Duty2 = ", Dec wDuty2, " Duty3 = ", Dec wDuty3
    Loop
    
'-----------------------------------------------------------------------------------------
' Setup the fuses for internal oscillator
'
    Config1 FOSC_INTOSC, WDTE_OFF, PWRTE_OFF, MCLRE_ON, CP_OFF, BOREN_OFF, CLKOUTEN_OFF
    Config2 PLLEN_OFF, LVP_OFF, BORV_LO, WRT_OFF, STVREN_OFF, LPBOREN_OFF  
